<?php
/*
	Plugin Name: WP-SongoftheDay
	Plugin URI: http://www.normansblog.de/webdesign/plugins
	Description: Show your current favourite song as a widget in your sidebar.
	Version: 1.0
	Author: Norman Paschke
	Author URI: http://www.normansblog.de

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

//initially set the options
function wp_sotd_install () {
	$newoptions = get_option('wpsotd_options');
	$newoptions['title'] = '';
	$newoptions['artist'] = '';
	$newoptions['stitle'] = '';
	$newoptions['atmode'] = 'next';
	$newoptions['album'] = '';
	$newoptions['width'] = '50';
	$newoptions['height'] = '50';
	$newoptions['coverurl'] = '';
	$newoptions['year'] = '';
	$newoptions['yturl'] = '';
	$newoptions['target'] = 'false';
	add_option('wpsotd_options', $newoptions);
	// widget options
	$widgetoptions = get_option('wpsotd_widget');
	$newoptions['title'] = '';
	$newoptions['artist'] = '';
	$newoptions['stitle'] = '';
	$newoptions['atmode'] = 'next';
	$newoptions['album'] = '';
	$newoptions['width'] = '50';
	$newoptions['height'] = '50';
	$newoptions['coverurl'] = '';
	$newoptions['year'] = '';
	$newoptions['yturl'] = '';
	$newoptions['target'] = 'false';
	add_option('wpsotd_widget', $newoptions);
}

// replace tag in content with tag cloud (non-shortcode version for WP 2.3.x)
function wp_sotd_init($content){
	if( strpos($content, '[WP-SOTD]') === false ){
		return $content;
	} else {
		$code = wp_sotd_createcode(false);
		$content = str_replace( '[WP-SOTD]', $code, $content );
		return $content;
	}
}

// template function
function wp_sotd_insert( $atts=NULL ){
	echo wp_sotd_createcode( false, $atts );
}

// shortcode function
function wp_sotd_shortcode( $atts=NULL ){
	return wp_sotd_createcode( false, $atts );
}

// piece together the flash code
function wp_sotd_createcode( $widget=false, $atts=NULL ){
	// get the options
	if( $widget == true ){
		$options = get_option('wpsotd_widget');
		$soname = "widget_so";
		$divname = "wpsotdwidgetcontent";
		// get compatibility mode variable from the main options
		$mainoptions = get_option('wpsotd_options');
		$options['compmode'] = $mainoptions['compmode'];
	} else if( $atts != NULL ){
		$options = shortcode_atts( get_option('wpsotd_options'), $atts );
		$soname = "shortcode_so";
		$divname = "wpsotdcontent";
	} else {
		$options = get_option('wpsotd_options');
		$soname = "so";
		$divname = "wpsotdcontent";
	}

	// write content
	if( $options['compmode']!='true' ){
		$sotdcontent = '<div id="'.$divname.'">';
		
		$sotdcontent .= '<p>';
		if (!empty($options['yturl'])) {
			$sotdcontent .= '<a style="display:block;" href="'.$options['yturl'].'" ';
			if ($options['target'] == 'true') {
				$sotdcontent .= 'target="_blank"';
			}
			$sotdcontent .= '>';
		}
			
			if (!empty($options['coverurl'])) {
				$sotdcontent .= '<img class="albumcover" style="float:left;width:'.$options['width'].'px;height:'.$options['height'].'px;margin-right:10px;" src="'.$options['coverurl'].'" alt="Album Cover"/>';
			}
			
			$sotdcontent .= '<span title="Artist" class="artist">'.$options['artist'].'</span>';
			if ($options['atmode'] == 'next') {
				$sotdcontent .= '&nbsp;- ';
			} else {
				$sotdcontent .= '<br/>';
			}
			$sotdcontent .= '<span title="Song Title" class="title">'.$options['stitle'].'</span>';
			
			if (!empty($options['album'])) {
				$sotdcontent .= '<br/><span title="Album Title" class="album">'.$options['album'].'</span>';
			}
			
			if (!empty($options['year'])) {
				$sotdcontent .= '&nbsp;<span class="year">('.$options['year'].')</span>';
			}
			
		if (!empty($options['yturl'])) {
			$sotdcontent .= '</a>';
		}
		
		$sotdcontent .= '</p><div style="clear:both;"></div></div>';
	}
	return $sotdcontent;
}

//uninstall all options
function wp_sotd_uninstall () {
	delete_option('sotd_options');
	delete_option('sotd_widget');
}

// widget
function widget_init_wp_sotd_widget() {
	// Check for required functions
	if (!function_exists('register_sidebar_widget'))
		return;

	function wp_sotd_widget($args){
	    extract($args);
		$options = get_option('wpsotd_widget');
		$title = empty($options['title']) ? __('Song of the Day') : $options['title'];
		?>
	        <?php echo $before_widget; ?>
				<?php echo $before_title . $title . $after_title; ?>
				<?php 
					if( !stristr( $_SERVER['PHP_SELF'], 'widgets.php' ) ){
						echo wp_sotd_createcode(true);
					}
				?>
	        <?php echo $after_widget; ?>
		<?php
	}
	
	function wp_sotd_widget_control() {
		$options = $newoptions = get_option('wpsotd_widget');
		if ( $_POST["wpsotd_widget_submit"] ) {
			$newoptions['title'] = strip_tags(stripslashes($_POST["wpsotd_widget_title"]));
			$newoptions['artist'] = strip_tags(stripslashes($_POST["wpsotd_widget_artist"]));
			$newoptions['stitle'] = strip_tags(stripslashes($_POST["wpsotd_widget_stitle"]));
			$newoptions['atmode'] = strip_tags(stripslashes($_POST["wpsotd_widget_atmode"]));
			$newoptions['album'] = strip_tags(stripslashes($_POST["wpsotd_widget_album"]));
			$newoptions['coverurl'] = strip_tags(stripslashes($_POST["wpsotd_widget_coverurl"]));
			$newoptions['width'] = strip_tags(stripslashes($_POST["wpsotd_widget_width"]));
			$newoptions['height'] = strip_tags(stripslashes($_POST["wpsotd_widget_height"]));
			$newoptions['year'] = strip_tags(stripslashes($_POST["wpsotd_widget_year"]));
			$newoptions['yturl'] = strip_tags(stripslashes($_POST["wpsotd_widget_yturl"]));
			$newoptions['target'] = strip_tags(stripslashes($_POST["wpsotd_widget_target"]));
		}
		if ( $options != $newoptions ) {
			$options = $newoptions;
			update_option('wpsotd_widget', $options);
		}
		$title = attribute_escape($options['title']);
		$artist = attribute_escape($options['artist']);
		$stitle = attribute_escape($options['stitle']);
		$atmode = attribute_escape($options['atmode']);
		$album = attribute_escape($options['album']);
		$coverurl = attribute_escape($options['coverurl']);
		$width = attribute_escape($options['width']);
		$height = attribute_escape($options['height']);
		$year = attribute_escape($options['year']);
		$yturl = attribute_escape($options['yturl']);
		$target = attribute_escape($options['target']);
		
		$req = '<span style="color:#f00;">*</span>';
		?>
			<p><label for="wpsotd_widget_title"><?php _e('Sidebar Title:'); ?> <input class="widefat" id="wpsotd_widget_title" name="wpsotd_widget_title" type="text" value="<?php echo $title; ?>" /></label></p>
			<p><label for="wpsotd_widget_artist"><?php _e('Artist:'.$req); ?> <input class="widefat" id="wpsotd_widget_artist" name="wpsotd_widget_artist" type="text" value="<?php echo $artist; ?>" /></label></p>
			<p><label for="wpsotd_widget_stitle"><?php _e('Song Title:'.$req); ?> <input class="widefat" id="wpsotd_widget_stitle" name="wpsotd_widget_stitle" type="text" value="<?php echo $stitle; ?>" /></label></p>
			<p>Artist and Song Title:<br/>
				<input class="radio" name="wpsotd_widget_atmode" type="radio" value="next" <?php if( $atmode == "next" ){ echo ' checked="checked"'; } ?>/> next to eachother<br/>
				<input class="radio" name="wpsotd_widget_atmode" type="radio" value="below" <?php if( $atmode == "below" ){ echo ' checked="checked"'; } ?>/> below eachother</p>
			<p><label for="wpsotd_widget_album"><?php _e('Album Title:'); ?> <input class="widefat" id="wpsotd_widget_album" name="wpsotd_widget_album" type="text" value="<?php echo $album; ?>" /></label></p>
			<p><label for="wpsotd_widget_coverurl"><?php _e('Album Cover URL:'); ?> <input class="widefat" id="wpsotd_widget_coverurl" name="wpsotd_widget_coverurl" type="text" style="margin-bottom:5px;" value="<?php echo $coverurl; ?>" /></label>
				<br/><label for="wpsotd_widget_width"><?php _e('Width:'); ?> <input class="widefat" id="wpsotd_widget_width" name="wpsotd_widget_width" type="text" maxlength="3" style="width:35px;" value="<?php echo $width; ?>" />px&nbsp;</label>
				<label for="wpsotd_widget_height"><?php _e('Height:'); ?> <input class="widefat" id="wpsotd_widget_height" name="wpsotd_widget_height" type="text" maxlength="3" style="width:35px;" value="<?php echo $height; ?>" />px</label></p>
			<p><label for="wpsotd_widget_year"><?php _e('Year of Release:'); ?> <input class="widefat" id="wpsotd_widget_year" name="wpsotd_widget_year" type="text" maxlength="4" style="width:45px;" value="<?php echo $year; ?>" /></label></p>
			<p><label for="wpsotd_widget_yturl"><?php _e('URL:'); ?> <small>(e.g. Video on Youtube)</small> <input class="widefat" id="wpsotd_widget_yturl" name="wpsotd_widget_yturl" type="text" style="margin-bottom:5px;" value="<?php echo $yturl; ?>" /></label><br/>
				<label for="wpsotd_widget_target"><input id="wpsotd_widget_target" class="checkbox" name="wpsotd_widget_target" type="checkbox" value="true" <?php if( $target == "true" ){ echo ' checked="checked"'; } ?>/> use target="_blank"</label></p>
			<p><span style="color:#f00;">* = required</span></p>
			<input type="hidden" id="wpsotd_widget_submit" name="wpsotd_widget_submit" value="1" />
		<?php
	}
	
	register_sidebar_widget( "WP-SongoftheDay", wp_sotd_widget );
	register_widget_control( "WP-SongoftheDay", "wp_sotd_widget_control" );
}

// Delay plugin execution until sidebar is loaded
add_action('widgets_init', 'widget_init_wp_sotd_widget');

// add the actions
register_activation_hook( __FILE__, 'wp_sotd_install' );
register_deactivation_hook( __FILE__, 'wp_sotd_uninstall' );
if( function_exists('add_shortcode') ){
	add_shortcode('wp-sotd', 'wp_sotd_shortcode');
	add_shortcode('WP-SongoftheDay', 'wp_sotd_shortcode');
} else {
	add_filter('the_content','wp_sotd_init');
}

?>
